(($, Drupal, once) => {
  Drupal.behaviors.sobkiAdminSelectIconsOpacity = {
    attach(context) {
      const fields = [
        {
          color: 'ui_styles_wrapper[texte][ui_styles_colors_color]',
          opacity: 'ui_styles_wrapper[texte][ui_styles_colors_opacity]',
        },
        {
          color: 'ui_styles_title[texte][ui_styles_colors_color]',
          opacity: 'ui_styles_title[texte][ui_styles_colors_opacity]',
        },
        {
          color: 'ui_styles[texte][ui_styles_colors_color]',
          opacity: 'ui_styles[texte][ui_styles_colors_opacity]',
        },
      ];

      for (const f in fields) {
        const field = fields[f];
        const opacityFieldSelector = `select[name="${field.opacity}"]`;
        const id = $(opacityFieldSelector).attr('id');
        const selectMenuSelector = `span#${id}-button`;

        // Wait for the element to exist, then store related color field name on the opacity field and add behavior.
        this.waitForElm(selectMenuSelector).then((elm) => {
          $(selectMenuSelector).attr(
            'data-sobki-admin-color-field',
            `select[name="${field.color}"]`,
          );
          $(selectMenuSelector).attr('data-sobki-admin-previous-value', '');
          once(
            `sobkiAdminSelectIconsOpacity-${f}`,
            `span#${id}-button`,
            context,
          ).forEach((link) => {
            $(link).click((e) => {
              const id = $(e.currentTarget)
                .attr('id')
                .substring(0, $(e.currentTarget).attr('id').length - 7);
              const field = $(e.currentTarget).attr(
                'data-sobki-admin-color-field',
              );
              const value = $(field).val();
              const previousValue = $(e.currentTarget).attr(
                'data-sobki-admin-previous-value',
              );
              $(e.currentTarget).attr('data-sobki-admin-previous-value', value);

              $(`ul#${id}-menu li span`).each(function (index) {
                $(this).removeClass(previousValue);
                $(this).addClass(value);
                $(this).attr('style', `opacity:${$(this).text()};`);
              });
            });
          });
        });
      }
    },
    waitForElm(selector) {
      return new Promise((resolve) => {
        if (document.querySelector(selector)) {
          return resolve(document.querySelector(selector));
        }

        const observer = new MutationObserver((mutations) => {
          if (document.querySelector(selector)) {
            observer.disconnect();
            resolve(document.querySelector(selector));
          }
        });

        observer.observe(document.body, {
          childList: true,
          subtree: true,
        });
      });
    },
  };
})(jQuery, Drupal, once);
